"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initialize = exports.DVCPopulatedUser = exports.initializeDevCycle = exports.dvcDefaultLogger = void 0;
const Client_1 = require("./Client");
__exportStar(require("./types"), exports);
var logger_1 = require("./logger");
Object.defineProperty(exports, "dvcDefaultLogger", { enumerable: true, get: function () { return logger_1.dvcDefaultLogger; } });
const determineUserAndOptions = (userOrOptions, optionsArg = {}) => {
    let user = undefined;
    if (!!userOrOptions && 'deferInitialization' in userOrOptions) {
        if (userOrOptions.deferInitialization) {
            return {
                user: undefined,
                options: userOrOptions,
                isDeferred: true,
            };
        }
    }
    else {
        user = userOrOptions;
    }
    if (!user) {
        throw new Error('Missing user! Call initialize with a valid user');
    }
    return { user, options: optionsArg, isDeferred: false };
};
function initializeDevCycle(sdkKey, userOrOptions, optionsArg = {}) {
    if (!sdkKey) {
        throw new Error('Missing SDK key! Call initialize with a valid SDK key');
    }
    const userAndOptions = determineUserAndOptions(userOrOptions, optionsArg);
    const { options } = userAndOptions;
    // TODO: implement logger
    if (typeof window === 'undefined' && !options.next) {
        console.warn('Window is not defined, try initializing in a browser context');
    }
    if (typeof window !== 'undefined' &&
        !window.addEventListener &&
        !(options === null || options === void 0 ? void 0 : options.reactNative)) {
        throw new Error('Window is not defined, try initializing in a browser context.' +
            ' If running on React Native, initialize with the option reactNative: true');
    }
    if ((options === null || options === void 0 ? void 0 : options.reactNative) && !globalThis.DeviceInfo) {
        throw new Error('DeviceInfo is not defined. ' +
            'Import react-native-device-info and set global.DeviceInfo when running on React Native');
    }
    if (!options || options === null) {
        throw new Error('Invalid options! Call initialize with valid options');
    }
    let client;
    if (userAndOptions.isDeferred) {
        client = new Client_1.DevCycleClient(sdkKey, undefined, userAndOptions.options);
    }
    else {
        client = new Client_1.DevCycleClient(sdkKey, userAndOptions.user, userAndOptions.options);
    }
    client
        .onClientInitialized()
        .then(() => client.logger.info('Successfully initialized DevCycle!'))
        .catch((err) => client.logger.error(`Error initializing DevCycle: ${err}`));
    return client;
}
exports.initializeDevCycle = initializeDevCycle;
var User_1 = require("./User");
Object.defineProperty(exports, "DVCPopulatedUser", { enumerable: true, get: function () { return User_1.DVCPopulatedUser; } });
/**
 * @deprecated Use initializeDevCycle instead
 */
exports.initialize = initializeDevCycle;
//# sourceMappingURL=index.js.map